Note: This is a public test instance of Red Hat Bugzilla. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback at bugzilla.redhat.com.
Bug 1832623 - Review Request: psi-notify - Alert when your machine is becoming over-saturated
Summary: Review Request: psi-notify - Alert when your machine is becoming over-saturated
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Stuart D Gathman
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
: 1834403 (view as bug list)
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2020-05-06 22:54 UTC by Michel Alexandre Salim
Modified: 2020-05-24 01:01 UTC (History)
4 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2020-05-17 02:42:25 UTC
Type: ---
stuart: fedora-review+


Attachments (Terms of Use)

Description Michel Alexandre Salim 2020-05-06 22:54:33 UTC
Spec URL: https://salimma.fedorapeople.org/specs/utils/psi-notify.spec
SRPM URL: https://salimma.fedorapeople.org/specs/utils/psi-notify-1.0.1-1.fc32.src.rpm
Description: 
psi-notify is a minimal unprivileged notifier for system-wide resource pressure
using PSI.

This can help you to identify misbehaving applications on your machine before
they start to severely impact system responsiveness, in a way which MemAvailable
or other metrics cannot.

Fedora Account System Username: salimma

Comment 1 Stuart D Gathman 2020-05-07 15:41:25 UTC
I'll take this.  What does PSI stand for?  Psychic System Intuition ?  :-)

Comment 2 Michel Alexandre Salim 2020-05-07 16:57:27 UTC
Pressure Stall Information -- but I like Psychic System Intuition better :)

I think it's also a US/UK pun, since psi is an Imperial unit of pressure :)

Comment 3 Michel Alexandre Salim 2020-05-07 16:58:00 UTC
https://facebookmicrosites.github.io/psi/docs/overview

Comment 4 Michel Alexandre Salim 2020-05-07 19:02:53 UTC
Thanks for taking this Stuart. Could you set this to assigned and set the fedora-review flag?

Comment 5 Michel Alexandre Salim 2020-05-07 20:47:08 UTC
I think it's supposed to stay at '?' until you approve the package :)

Comment 6 Stuart D Gathman 2020-05-08 01:03:11 UTC
Sorry for taking so long.  This is my first formal review.  The package looks great to me, and built no problem, but I am trying to get the fedora-review package to run.  I may have to just go through the checklist manually.

Comment 7 Michel Alexandre Salim 2020-05-08 03:40:03 UTC
(In reply to Stuart D Gathman from comment #6)
> Sorry for taking so long.  This is my first formal review.  The package
> looks great to me, and built no problem, but I am trying to get the
> fedora-review package to run.  I may have to just go through the checklist
> manually.

no worries! This is probably a great package to start with as it's quite simple.

Replied on IRC, but this should work:

fedora-review -b 1832623 -m fedora-32-x86_64

Comment 8 Stuart D Gathman 2020-05-08 14:09:45 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated


Issues:
=======
- systemd_user_post is invoked in %post and systemd_user_preun in %preun
  for Systemd user units service files.
  Note: Systemd user unit service file(s) in psi-notify
  See: https://docs.fedoraproject.org/en-US/packaging-guidelines/Scriptlets/#_user_units

Reviewer note: the user service is enabled by default for all users.  I can see
  the reason for this (we are installing an extension to the desktop
  environments), but maybe the description should mention this.

- the (one) source file does not have a copyright in the source.  Advise
  upstream to include a copyright notice and reference the license in the
  source.  Or is this no longer recommended?

- Technically there should be a Requires: systemd - although this seems
  rather pedantic as all Fedora systems, including EPEL as of Nov, have
  systemd.  Maybe this is a bug in fedora-review.  It complains
  that e.g. /usr/lib/systemd has no documented owner. 

- Should demo.gif be included in %doc ?

===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: If your application is a C or C++ application you must list a
     BuildRequires against gcc, gcc-c++ or clang.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
     Note: Using prebuilt packages
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "Expat License". 6 files have unknown
     license. Detailed output of licensecheck in /home/stuart/fedora-
     scm/psi-notify/review-psi-notify/licensecheck.txt
[-]: License file installed when any subpackage combination is installed.
[x]: Package must own all directories that it creates.
     Note: Directories without known owners: /usr/lib/systemd,
     /usr/lib/systemd/user
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[x]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[x]: Reviewer should test that the package builds in mock.
[x]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[?]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: psi-notify-1.0.1-1.fc32.x86_64.rpm
          psi-notify-debuginfo-1.0.1-1.fc32.x86_64.rpm
          psi-notify-debugsource-1.0.1-1.fc32.x86_64.rpm
          psi-notify-1.0.1-1.fc32.src.rpm
psi-notify.x86_64: W: no-manual-page-for-binary psi-notify
4 packages and 0 specfiles checked; 0 errors, 1 warnings.




Rpmlint (debuginfo)
-------------------
Checking: psi-notify-debuginfo-1.0.1-1.fc32.x86_64.rpm
1 packages and 0 specfiles checked; 0 errors, 0 warnings.





Rpmlint (installed packages)
----------------------------
psi-notify-debugsource.x86_64: W: invalid-url URL: https://github.com/cdown/psi-notify <urlopen error [Errno -2] Name or service not known>
psi-notify-debuginfo.x86_64: W: invalid-url URL: https://github.com/cdown/psi-notify <urlopen error [Errno -2] Name or service not known>
psi-notify.x86_64: W: invalid-url URL: https://github.com/cdown/psi-notify <urlopen error [Errno -2] Name or service not known>
psi-notify.x86_64: W: no-manual-page-for-binary psi-notify
3 packages and 0 specfiles checked; 0 errors, 4 warnings.



Source checksums
----------------
https://github.com/cdown/psi-notify/archive/1.0.1.tar.gz#/psi-notify-1.0.1.tar.gz :
  CHECKSUM(SHA256) this package     : e3cb4a6dcea3c6541e1884235d4c6c445f1a0486bd3e9cad660af31b795b25b8
  CHECKSUM(SHA256) upstream package : e3cb4a6dcea3c6541e1884235d4c6c445f1a0486bd3e9cad660af31b795b25b8


Requires
--------
psi-notify (rpmlib, GLIBC filtered):
    /bin/sh
    libc.so.6()(64bit)
    libgdk_pixbuf-2.0.so.0()(64bit)
    libgio-2.0.so.0()(64bit)
    libglib-2.0.so.0()(64bit)
    libgobject-2.0.so.0()(64bit)
    libnotify.so.4()(64bit)
    libpthread.so.0()(64bit)
    libsystemd.so.0()(64bit)
    libsystemd.so.0(LIBSYSTEMD_209)(64bit)
    rtld(GNU_HASH)

psi-notify-debuginfo (rpmlib, GLIBC filtered):

psi-notify-debugsource (rpmlib, GLIBC filtered):



Provides
--------
psi-notify:
    psi-notify
    psi-notify(x86-64)

psi-notify-debuginfo:
    debuginfo(build-id)
    psi-notify-debuginfo
    psi-notify-debuginfo(x86-64)

psi-notify-debugsource:
    psi-notify-debugsource
    psi-notify-debugsource(x86-64)



Generated by fedora-review 0.7.5 (5fa5b7e) last change: 2020-02-16
Command line :/usr/bin/fedora-review -m fedora-32-x86_64 -p -n psi-notify
Buildroot used: fedora-32-x86_64
Active plugins: C/C++, Generic, Shell-api
Disabled plugins: Python, Haskell, R, PHP, SugarActivity, Ocaml, Perl, Java, fonts
Disabled flags: EPEL6, EPEL7, DISTTAG, BATCH, EXARCH

Comment 9 Michel Alexandre Salim 2020-05-08 16:47:27 UTC
(In reply to Stuart D Gathman from comment #8)

Thanks for the thorough review! Going to comment in-line.

> Package Review
> ==============
> 
> Legend:
> [x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
> 
> 
> Issues:
> =======
> - systemd_user_post is invoked in %post and systemd_user_preun in %preun
>   for Systemd user units service files.
>   Note: Systemd user unit service file(s) in psi-notify
>   See:
> https://docs.fedoraproject.org/en-US/packaging-guidelines/Scriptlets/
> #_user_units
> 
> Reviewer note: the user service is enabled by default for all users.  I can
> see
>   the reason for this (we are installing an extension to the desktop
>   environments), but maybe the description should mention this.
> 
They should not be; from the docs: "These enable and disable user units according to presets". And the presets default to disabling every unit that's not whitelisted; so the intention is a sysadmin / org can ship a custom preset and pre-enable some services.

~
❯ systemctl --user status psi-notify
● psi-notify.service
     Loaded: loaded (/usr/lib/systemd/user/psi-notify.service; disabled; vendor preset: disabled)

~
❯ ls /usr/lib/systemd/user-preset 
90-default-user.preset  90-systemd.preset  99-default-disable.preset

~
❯ cat /usr/lib/systemd/user-preset/99-default-disable.preset 
disable *



❯ rpm -E '%systemd_user_post'

 
if [ $1 -eq 1 ] && [ -x /usr/bin/systemctl ] ; then 
        # Initial installation 
        /usr/bin/systemctl --no-reload preset \--global  || : 
fi 


~
❯ rpm -E '%systemd_user_preun'
error: This macro requires some arguments

~
❯ rpm -E '%systemd_user_preun psi-notify'

 
if [ $1 -eq 0 ] && [ -x /usr/bin/systemctl ] ; then 
        # Package removal, not upgrade 
        /usr/bin/systemctl --global disable psi-notify || : 
fi 


> - the (one) source file does not have a copyright in the source.  Advise
>   upstream to include a copyright notice and reference the license in the
>   source.  Or is this no longer recommended?
That's definitely recommended. I'll notify upstream. Thanks for noticing!

> 
> - Technically there should be a Requires: systemd - although this seems
>   rather pedantic as all Fedora systems, including EPEL as of Nov, have
>   systemd.  Maybe this is a bug in fedora-review.  It complains
>   that e.g. /usr/lib/systemd has no documented owner.
Yes, need to include something for file ownership.
 
> 
> - Should demo.gif be included in %doc ?
Will add that.

Comment 10 Michel Alexandre Salim 2020-05-08 16:58:13 UTC
so - looking at the file/directory ownership guidelines; since psi-notify actually works fine if you run it from the CLI, without using the systemd unit, I'm going to just make it co-own /usr/lib/systemd/user:

https://docs.fedoraproject.org/en-US/packaging-guidelines/#_the_directory_is_owned_by_a_package_which_is_not_required_for_your_package_to_function

it does pull in systemd-libs because it's compiled against it, but this is a much smaller surface than pulling in the entire systemd -- in case someone wants to run this in a minimal environment (e.g. a container). note that the scriptlets already check if systemctl is executable so they don't pre-assume systemd is installed.

Comment 11 Michel Alexandre Salim 2020-05-08 17:20:52 UTC
Spec URL: https://salimma.fedorapeople.org/specs/utils/psi-notify.spec
SRPM URL: https://salimma.fedorapeople.org/specs/utils/psi-notify-1.0.1-1.fc32.src.rpm

all the changes requested, except I have not requested the license header from upstream yet -- still trying to find an example of a major project that does this for reference (e.g. a lot of Rust code is dual-MIT-Apache licensed but the few I just checked don't have per-file license headers :/

Comment 12 Stuart D Gathman 2020-05-08 17:59:02 UTC
In Fedora 31:

$ rpm -ql fedora-release-common | grep user-preset
/usr/lib/systemd/user-preset
/usr/lib/systemd/user-preset/90-default-user.preset

In Fedora 32:

$ rpm -ql fedora-release-common | grep user-preset
/usr/lib/systemd/user-preset
/usr/lib/systemd/user-preset/90-default-user.preset
/usr/lib/systemd/user-preset/99-default-disable.preset

That is why it was enabled by default on F31.  So it won't be a problem going forward.

Comment 13 Stuart D Gathman 2020-05-08 19:29:41 UTC
I think it is good enough now.  Setting the flag to +

Comment 14 Stuart D Gathman 2020-05-08 19:33:25 UTC
I will continue to investigate whether the additional clause in the MIT license variant is an issue:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

Since this is already a Fedora requirement anyway, I don't see how it could be an issue - but IANAL.

Comment 15 Stuart D Gathman 2020-05-08 19:46:02 UTC
nvm - It is the "feh" variant.  We are good to go.  Do I need to close the bug?

Comment 16 Michel Alexandre Salim 2020-05-08 20:19:48 UTC
(In reply to Stuart D Gathman from comment #12)
> In Fedora 31:
> 
> $ rpm -ql fedora-release-common | grep user-preset
> /usr/lib/systemd/user-preset
> /usr/lib/systemd/user-preset/90-default-user.preset
> 
> In Fedora 32:
> 
> $ rpm -ql fedora-release-common | grep user-preset
> /usr/lib/systemd/user-preset
> /usr/lib/systemd/user-preset/90-default-user.preset
> /usr/lib/systemd/user-preset/99-default-disable.preset
> 
> That is why it was enabled by default on F31.  So it won't be a problem
> going forward.

Oh, good to know. I'll gate it to Fedora 32 and above before committing then. Thanks for checking! I wrote this the day after I upgraded my last F31 machine, of course, heh.

No need to close the bug, I'll assign it back to myself and link it to the package being pushed so Bodhi will close this when it hits stable. Thanks so much!

(also since somebody sniped the package you wanted reviewed, feel free to ask for a review next time)

Comment 17 Michel Alexandre Salim 2020-05-08 20:38:42 UTC
TIL changing the assignee before requesting a repo is a bad idea

Comment 18 Gwyn Ciesla 2020-05-08 20:45:40 UTC
(fedscm-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/psi-notify

Comment 19 Fedora Update System 2020-05-08 22:13:13 UTC
FEDORA-2020-b64e30a1a9 has been submitted as an update to Fedora 32. https://bodhi.fedoraproject.org/updates/FEDORA-2020-b64e30a1a9

Comment 20 Fedora Update System 2020-05-08 22:13:14 UTC
FEDORA-EPEL-2020-d68638b361 has been submitted as an update to Fedora EPEL 8. https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2020-d68638b361

Comment 21 Fedora Update System 2020-05-08 22:13:15 UTC
FEDORA-2020-19e39ee9d7 has been submitted as an update to Fedora 31. https://bodhi.fedoraproject.org/updates/FEDORA-2020-19e39ee9d7

Comment 22 Fedora Update System 2020-05-09 03:30:47 UTC
FEDORA-EPEL-2020-d68638b361 has been pushed to the Fedora EPEL 8 testing repository.

You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2020-d68638b361

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 23 Fedora Update System 2020-05-09 04:38:55 UTC
FEDORA-2020-19e39ee9d7 has been pushed to the Fedora 31 testing repository.
In short time you'll be able to install the update with the following command:
`sudo dnf install --enablerepo=updates-testing --advisory=FEDORA-2020-19e39ee9d7 \*`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2020-19e39ee9d7

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 24 Fedora Update System 2020-05-09 06:41:49 UTC
FEDORA-2020-b64e30a1a9 has been pushed to the Fedora 32 testing repository.
In short time you'll be able to install the update with the following command:
`sudo dnf install --enablerepo=updates-testing --advisory=FEDORA-2020-b64e30a1a9 \*`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2020-b64e30a1a9

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 25 Fedora Update System 2020-05-17 02:42:25 UTC
FEDORA-2020-b64e30a1a9 has been pushed to the Fedora 32 stable repository.
If problem still persists, please make note of it in this bug report.

Comment 26 Fedora Update System 2020-05-17 03:48:45 UTC
FEDORA-2020-19e39ee9d7 has been pushed to the Fedora 31 stable repository.
If problem still persists, please make note of it in this bug report.

Comment 27 Zbigniew Jędrzejewski-Szmek 2020-05-21 12:23:16 UTC
*** Bug 1834403 has been marked as a duplicate of this bug. ***

Comment 28 Fedora Update System 2020-05-24 01:01:25 UTC
FEDORA-EPEL-2020-d68638b361 has been pushed to the Fedora EPEL 8 stable repository.
If problem still persists, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.